#   Copyright (c) 2021 Boulder Real Time Technologies, Inc.
#
#   This software module is wholly owned by Boulder Real Time
#   Technologies, Inc. Any use of this software module without
#   express written permission from Boulder Real Time Technologies,
#   Inc. is prohibited.
#
#   Author: Ambli LLC (ambli.ll.company@gmail.com)

import os
import mock
import json
from http import HTTPStatus
from flask import make_response

from webservice_fdsn.tests.api import BaseApiTestCase


class TestStationApi(BaseApiTestCase):

    def setUp(self):
        self.baseurl = '/fdsnws/station/1'

    def test_get_version(self):
        resp = self.client.open(f'{self.baseurl}/version', method='GET')
        self.assertEqual(resp.status_code, HTTPStatus.OK)

    def test_get_application_wadl(self):
        resp = self.client.open(f'{self.baseurl}/application.wadl', method='GET')
        self.assertEqual(resp.status_code, HTTPStatus.OK)

    """
    BROKEN: AssertionError: 204 != <HTTPStatus.OK: 200>
    Also, mock not working.
    @mock.patch('webservice_fdsn.app.v1_1_b.controllers.station_controller.get_station')
    def test_query_get_ok(self, mocked_controller):
        mocked_controller.return_value = make_response('', HTTPStatus.NO_CONTENT)
        url = f'{self.baseurl}/query?starttime=123&network=.*&station=.*&channel=.*&location=.*'\
               '&minlatitude=-90&maxlatitude=90&minlongitude=-180&maxlongitude=180&level=network&nodata=204'
        resp = self.client.open(url, method='GET')
        self.assertEqual(resp.status_code, HTTPStatus.OK)
	"""
    def test_query_missing_req_args(self):
        url = f'{self.baseurl}/query?starttime=123.4&channel=ch&location=loc'
        resp = self.client.open(url, method='GET')
        self.assertNotEqual(resp.status_code, HTTPStatus.BAD_REQUEST)

        url = f'{self.baseurl}/query?station=MM&starttime=123.4&location=loc'
        resp = self.client.open(url, method='GET')
        self.assertNotEqual(resp.status_code, HTTPStatus.BAD_REQUEST)

        url = f'{self.baseurl}/query?station=MM&starttime=123.4&channel=ch'
        resp = self.client.open(url, method='GET')
        self.assertNotEqual(resp.status_code, HTTPStatus.BAD_REQUEST)